package diagnosticreport

import (
	"context"
	"service/internal/infrastructure/database"
	"service/pkg/utils/query"
)

type Repository interface {
	GetNextDiagnosticReport(ctx context.Context, lastID int64) (*DiagnosticReportDB, error)
	SaveSatuSehatID(ctx context.Context, idx int64, fhirID string) error
	SaveSyncLog(ctx context.Context, logData DiagnosticReportSyncLog) error
}

type repository struct {
	dbManager database.Service
}

func NewRepository(dbManager database.Service) Repository {
	return &repository{dbManager: dbManager}
}

func (r *repository) GetNextDiagnosticReport(ctx context.Context, lastID int64) (*DiagnosticReportDB, error) {
	var dr DiagnosticReportDB
	simrsDB, err := r.dbManager.GetSQLXDB("simrs")
	if err != nil {
		return nil, err
	}

	qb := query.NewSQLQueryBuilder(query.DBTypePostgreSQL).SetSecurityOptions(false, 0)

	// TODO: Sesuaikan nama tabel hasil diagnostik
	qSimrs := query.DynamicQuery{
		From: "public.t_hasil_lab",
		Filters: []query.FilterGroup{
			{
				Filters: []query.DynamicFilter{
					query.CreateFilter("idxhasil", query.OpGreaterThan, lastID),
				},
			},
		},
		Sort: []query.SortField{
			query.CreateAscSort("idxhasil"),
		},
		Limit: 1,
	}

	err = qb.ExecuteQueryRow(ctx, simrsDB, qSimrs, &dr)
	if err != nil {
		return nil, err
	}
	return &dr, nil
}

func (r *repository) SaveSatuSehatID(ctx context.Context, idx int64, fhirID string) error {
	simrsDB, err := r.dbManager.GetSQLXDB("simrs")
	if err != nil {
		return err
	}
	qb := query.NewSQLQueryBuilder(query.DBTypePostgreSQL).SetSecurityOptions(false, 0)
	_, err = qb.ExecuteUpdate(ctx, simrsDB, "public.t_hasil_lab", query.UpdateData{Columns: []string{"status_bridging"}, Values: []interface{}{fhirID}}, []query.FilterGroup{query.CreateAndFilterGroup([]query.DynamicFilter{query.CreateEqualFilter("idxhasil", idx)})})
	return err
}

func (r *repository) SaveSyncLog(ctx context.Context, logData DiagnosticReportSyncLog) error {
	simrsDB, err := r.dbManager.GetSQLXDB("simrs")
	if err != nil {
		return err
	}
	qb := query.NewSQLQueryBuilder(query.DBTypePostgreSQL).SetSecurityOptions(false, 0)
	insertData := query.InsertData{
		Columns: []string{"idxhasil", "diagnosticreport_id", "request_payload", "response_payload", "status", "error_message"},
		Values:  []interface{}{logData.IdxHasil, logData.DiagnosticReportID, logData.RequestPayload, logData.ResponsePayload, logData.Status, logData.ErrorMessage},
	}
	_, err = qb.ExecuteUpsert(ctx, simrsDB, "public.log_satusehat_diagnosticreport", insertData, []string{"idxhasil"}, []string{"diagnosticreport_id", "request_payload", "response_payload", "status", "error_message"})
	return err
}
